carlosjai.me

Advent of code – Day 2: Rock Paper Scissors

Galician

Parte un do problema.

O enunciado.

Vale, o enunciado está en inglés, e é unha matada traducilo. Así que podedes velo máis abaixo en inglés. Nun futuro, se teño tempo, tradúzoo.

Adaptando os datos de entrada.

Ok, utilizando o modo columna do Notepad++, e uns truquiños, convertín os datos de entrada en dous arrays de Strings, un para os nosos movementos, e outros para os movementos dos rivais.

A solución utilizando os datos adaptados.

Pois nada, que hai que xogar ao pedra, papel, tesoira. Temos os nosos movementos, e os do noso rival. Os puntos que vale cada xogada, e os puntos que nos dan polo movemento escollido. Só queda iterar e sumar.

import static data.DataInput.*;

import java.util.HashMap;
import java.util.Map;

public class AdventOfCode2 {
	static final String ROCK = "A";
	static final String PAPER = "B";
	static final String OUR_ROCK = "X";
	static final String OUR_PAPER = "Y";
	static final String OUR_SCISSORS = "Z";

	static final int WINING_POINTS = 6;
	static final int DRAW_POINTS = 3;

	static final Map<String, Integer> pointsBySelectedShape = new HashMap<>() {{
		put(OUR_ROCK, Integer.valueOf(1));
		put(OUR_PAPER, Integer.valueOf(2));
		put(OUR_SCISSORS, Integer.valueOf(3));
	}};

	public static void main(final String[] args) {
		//PART1
		int points = 0;
		for (int i = 0; i < theirMovements.length; i++) {
			points = points + getRoundPoints(theirMovements[i], ourMovements[i]);
		}
		System.out.println(points);
	}

	/**
	 * @param theirMovement
	 * 		A for Rock, B for Paper, and C for Scissors
	 * @param ourMovement
	 * 		X for Rock, Y for Paper, and Z for Scissors
	 * @return points (1 for Rock, 2 for Paper, and 3 for Scissors) + (0 if you lost, 3 if the round was a draw, and 6 if you won).
	 */
	private static int getRoundPoints(final String theirMovement, final String ourMovement) {
		final int points = pointsBySelectedShape.get(ourMovement);
		if (ROCK.equalsIgnoreCase(theirMovement)) {
			if (OUR_PAPER.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			} else if (OUR_SCISSORS.equalsIgnoreCase(ourMovement)) {
				return points;
			}
			return points + DRAW_POINTS;
		} else if (PAPER.equalsIgnoreCase(theirMovement)) {
			if (OUR_ROCK.equalsIgnoreCase(ourMovement)) {
				return points;
			} else if (OUR_SCISSORS.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			}
			return points + DRAW_POINTS;
		} else {
			if (OUR_ROCK.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			} else if (OUR_PAPER.equalsIgnoreCase(ourMovement)) {
				return points;
			}
			return points + DRAW_POINTS;
		}
	}

	}

}

Parte dous do problema.

O enunciado.

Vale, o enunciado está en inglés, e é unha matada traducilo. Así que podedes velo máis abaixo en inglés. Nun futuro, se teño tempo, tradúzoo.

A solución.

Temos que reutilizar os métodos anteriores, pero antes escollendo os movemenos que debemos facer, en base aos do rival, se queremos gañar, perder ou empatar. Os arrays están definidos en DataInput.

package adventofcode2022;

import static data.DataInput.*;

import java.util.HashMap;
import java.util.Map;

public class AdventOfCode2 {
	static final String ROCK = "A";
	static final String PAPER = "B";
	static final String OUR_ROCK = "X";
	static final String OUR_PAPER = "Y";
	static final String OUR_SCISSORS = "Z";
	static final String LOSE = "X";
	static final String WIN = "Z";

	static final int WINING_POINTS = 6;
	static final int DRAW_POINTS = 3;

	static final Map<String, Integer> pointsBySelectedShape = new HashMap<>() {{
		put(OUR_ROCK, Integer.valueOf(1));
		put(OUR_PAPER, Integer.valueOf(2));
		put(OUR_SCISSORS, Integer.valueOf(3));
	}};

	public static void main(final String[] args) {

		//PART1
		int points = 0;
		for (int i = 0; i < theirMovements.length; i++) {
			points = points + getRoundPoints(theirMovements[i], ourMovements[i]);
		}
		System.out.println(points);

		//PART 2
		points = 0;
		for (int i = 0; i < theirMovements.length; i++) {
			points = points + getStrategyRoundPoints(theirMovements[i], ourMovements[i]);
		}
		System.out.println(points);

	}

	/**
	 * @param theirMovement
	 * 		A for Rock, B for Paper, and C for Scissors
	 * @param ourMovement
	 * 		X for Rock, Y for Paper, and Z for Scissors
	 * @return points (1 for Rock, 2 for Paper, and 3 for Scissors) + (0 if you lost, 3 if the round was a draw, and 6 if you won).
	 */
	private static int getRoundPoints(final String theirMovement, final String ourMovement) {
		final int points = pointsBySelectedShape.get(ourMovement);
		if (ROCK.equalsIgnoreCase(theirMovement)) {
			if (OUR_PAPER.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			} else if (OUR_SCISSORS.equalsIgnoreCase(ourMovement)) {
				return points;
			}
			return points + DRAW_POINTS;
		} else if (PAPER.equalsIgnoreCase(theirMovement)) {
			if (OUR_ROCK.equalsIgnoreCase(ourMovement)) {
				return points;
			} else if (OUR_SCISSORS.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			}
			return points + DRAW_POINTS;
		} else {
			if (OUR_ROCK.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			} else if (OUR_PAPER.equalsIgnoreCase(ourMovement)) {
				return points;
			}
			return points + DRAW_POINTS;
		}
	}

	/**
	 * Obtains the shape based in our strategy, and gets the points for this round.
	 *
	 * @param theirMovement
	 * 		A for Rock, B for Paper, and C for Scissors
	 * @param ourDecission
	 * 		X  lose, Y  draw, and Z  win
	 * @return points (1 for Rock, 2 for Paper, and 3 for Scissors) + (0 if you lost, 3 if the round was a draw, and 6 if you won).
	 */
	private static int getStrategyRoundPoints(final String theirMovement, final String ourDecission) {
		final String shape = getShapeByStrategy(theirMovement, ourDecission);
		return getRoundPoints(theirMovement, shape);
	}

	/**
	 * Returns the shape needed to lose, draw or win based in the movement of our rival.
	 *
	 * @param theirMovement
	 * 		A for Rock, B for Paper, and C for Scissors
	 * @param ourDecission
	 * 		X  lose, Y  draw, and Z  win
	 * @return X for Rock, Y for Paper, and Z for Scissors
	 */
	private static String getShapeByStrategy(final String theirMovement, final String ourDecission) {
		if (ROCK.equalsIgnoreCase(theirMovement)) {
			if (LOSE.equalsIgnoreCase(ourDecission)) {
				return OUR_SCISSORS;
			} else if (WIN.equalsIgnoreCase(ourDecission)) {
				return OUR_PAPER;
			}
			return OUR_ROCK;
		} else if (PAPER.equalsIgnoreCase(theirMovement)) {
			if (LOSE.equalsIgnoreCase(ourDecission)) {
				return OUR_ROCK;
			} else if (WIN.equalsIgnoreCase(ourDecission)) {
				return OUR_SCISSORS;
			}
			return OUR_PAPER;
		} else {
			if (LOSE.equalsIgnoreCase(ourDecission)) {
				return OUR_PAPER;
			} else if (WIN.equalsIgnoreCase(ourDecission)) {
				return OUR_ROCK;
			}
			return OUR_SCISSORS;
		}
	}

}

Regresar á páxina principal do Advent of Code 2022.

English

Part 1 of the problem.

The statement

— Day 2: Rock Paper Scissors —

The Elves begin to set up camp on the beach. To decide whose tent gets to be closest to the snack storage, a giant Rock Paper Scissors tournament is already in progress.

Rock Paper Scissors is a game between two players. Each game contains many rounds; in each round, the players each simultaneously choose one of Rock, Paper, or Scissors using a hand shape. Then, a winner for that round is selected: Rock defeats Scissors, Scissors defeats Paper, and Paper defeats Rock. If both players choose the same shape, the round instead ends in a draw.

Appreciative of your help yesterday, one Elf gives you an encrypted strategy guide (your puzzle input) that they say will be sure to help you win. “The first column is what your opponent is going to play: A for Rock, B for Paper, and C for Scissors. The second column–” Suddenly, the Elf is called away to help with someone’s tent.

The second column, you reason, must be what you should play in response: X for Rock, Y for Paper, and Z for Scissors. Winning every time would be suspicious, so the responses must have been carefully chosen.

The winner of the whole tournament is the player with the highest score. Your total score is the sum of your scores for each round. The score for a single round is the score for the shape you selected (1 for Rock, 2 for Paper, and 3 for Scissors) plus the score for the outcome of the round (0 if you lost, 3 if the round was a draw, and 6 if you won).

Since you can’t be sure if the Elf is trying to help you or trick you, you should calculate the score you would get if you were to follow the strategy guide.

For example, suppose you were given the following strategy guide:

A Y
B X
C Z

This strategy guide predicts and recommends the following:

In the first round, your opponent will choose Rock (A), and you should choose Paper (Y). This ends in a win for you with a score of 8 (2 because you chose Paper + 6 because you won).

In the second round, your opponent will choose Paper (B), and you should choose Rock (X). This ends in a loss for you with a score of 1 (1 + 0).

-The third round is a draw with both players choosing Scissors, giving you a score of 3 + 3 = 6.

In this example, if you were to follow the strategy guide, you would get a total score of 15 (8 + 1 + 6).

What would your total score be if everything goes exactly according to your strategy guide?

Adapting the provided input data

Ok, using some Notepad++ column mode ,I splitted the input data in two columns, and with some tricks, I transform each column into a String array.

Solution using the adapted input.

Ok, we have to play Rock, paper, scissor. So we have their movements, and our movements. And the points of each movement, and the points for winning, losing and drawing. Note: in DataInput, I have declared each array.

import static data.DataInput.*;

import java.util.HashMap;
import java.util.Map;

public class AdventOfCode2 {
	static final String ROCK = "A";
	static final String PAPER = "B";
	static final String OUR_ROCK = "X";
	static final String OUR_PAPER = "Y";
	static final String OUR_SCISSORS = "Z";

	static final int WINING_POINTS = 6;
	static final int DRAW_POINTS = 3;

	static final Map<String, Integer> pointsBySelectedShape = new HashMap<>() {{
		put(OUR_ROCK, Integer.valueOf(1));
		put(OUR_PAPER, Integer.valueOf(2));
		put(OUR_SCISSORS, Integer.valueOf(3));
	}};

	public static void main(final String[] args) {
		//PART1
		int points = 0;
		for (int i = 0; i < theirMovements.length; i++) {
			points = points + getRoundPoints(theirMovements[i], ourMovements[i]);
		}
		System.out.println(points);
	}

	/**
	 * @param theirMovement
	 * 		A for Rock, B for Paper, and C for Scissors
	 * @param ourMovement
	 * 		X for Rock, Y for Paper, and Z for Scissors
	 * @return points (1 for Rock, 2 for Paper, and 3 for Scissors) + (0 if you lost, 3 if the round was a draw, and 6 if you won).
	 */
	private static int getRoundPoints(final String theirMovement, final String ourMovement) {
		final int points = pointsBySelectedShape.get(ourMovement);
		if (ROCK.equalsIgnoreCase(theirMovement)) {
			if (OUR_PAPER.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			} else if (OUR_SCISSORS.equalsIgnoreCase(ourMovement)) {
				return points;
			}
			return points + DRAW_POINTS;
		} else if (PAPER.equalsIgnoreCase(theirMovement)) {
			if (OUR_ROCK.equalsIgnoreCase(ourMovement)) {
				return points;
			} else if (OUR_SCISSORS.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			}
			return points + DRAW_POINTS;
		} else {
			if (OUR_ROCK.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			} else if (OUR_PAPER.equalsIgnoreCase(ourMovement)) {
				return points;
			}
			return points + DRAW_POINTS;
		}
	}

	}

}

Part 2 of the problem.

The statement.

The Elf finishes helping with the tent and sneaks back over to you. “Anyway, the second column says how the round needs to end: X means you need to lose, Y means you need to end the round in a draw, and Z means you need to win. Good luck!”

The total score is still calculated in the same way, but now you need to figure out what shape to choose so the round ends as indicated. The example above now goes like this:

In the first round, your opponent will choose Rock (A), and you need the round to end in a draw (Y), so you also choose Rock. This gives you a score of 1 + 3 = 4.

In the second round, your opponent will choose Paper (B), and you choose Rock so you lose (X) with a score of 1 + 0 = 1.

In the third round, you will defeat your opponent’s Scissors with Rock for a score of 1 + 6 = 7.

Now that you’re correctly decrypting the ultra top secret strategy guide, you would get a total score of 12.

Following the Elf’s instructions for the second column, what would your total score be if everything goes exactly according to your strategy guide?

Solution.

Ok we can reuse all the methods declared in part 1. But before that, we have to select the correct shape to lose, win or draw.

package adventofcode2022;

import static data.DataInput.*;

import java.util.HashMap;
import java.util.Map;

public class AdventOfCode2 {
	static final String ROCK = "A";
	static final String PAPER = "B";
	static final String OUR_ROCK = "X";
	static final String OUR_PAPER = "Y";
	static final String OUR_SCISSORS = "Z";
	static final String LOSE = "X";
	static final String WIN = "Z";

	static final int WINING_POINTS = 6;
	static final int DRAW_POINTS = 3;

	static final Map<String, Integer> pointsBySelectedShape = new HashMap<>() {{
		put(OUR_ROCK, Integer.valueOf(1));
		put(OUR_PAPER, Integer.valueOf(2));
		put(OUR_SCISSORS, Integer.valueOf(3));
	}};

	public static void main(final String[] args) {

		//PART1
		int points = 0;
		for (int i = 0; i < theirMovements.length; i++) {
			points = points + getRoundPoints(theirMovements[i], ourMovements[i]);
		}
		System.out.println(points);

		//PART 2
		points = 0;
		for (int i = 0; i < theirMovements.length; i++) {
			points = points + getStrategyRoundPoints(theirMovements[i], ourMovements[i]);
		}
		System.out.println(points);

	}

	/**
	 * @param theirMovement
	 * 		A for Rock, B for Paper, and C for Scissors
	 * @param ourMovement
	 * 		X for Rock, Y for Paper, and Z for Scissors
	 * @return points (1 for Rock, 2 for Paper, and 3 for Scissors) + (0 if you lost, 3 if the round was a draw, and 6 if you won).
	 */
	private static int getRoundPoints(final String theirMovement, final String ourMovement) {
		final int points = pointsBySelectedShape.get(ourMovement);
		if (ROCK.equalsIgnoreCase(theirMovement)) {
			if (OUR_PAPER.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			} else if (OUR_SCISSORS.equalsIgnoreCase(ourMovement)) {
				return points;
			}
			return points + DRAW_POINTS;
		} else if (PAPER.equalsIgnoreCase(theirMovement)) {
			if (OUR_ROCK.equalsIgnoreCase(ourMovement)) {
				return points;
			} else if (OUR_SCISSORS.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			}
			return points + DRAW_POINTS;
		} else {
			if (OUR_ROCK.equalsIgnoreCase(ourMovement)) {
				return points + WINING_POINTS;
			} else if (OUR_PAPER.equalsIgnoreCase(ourMovement)) {
				return points;
			}
			return points + DRAW_POINTS;
		}
	}

	/**
	 * Obtains the shape based in our strategy, and gets the points for this round.
	 *
	 * @param theirMovement
	 * 		A for Rock, B for Paper, and C for Scissors
	 * @param ourDecission
	 * 		X  lose, Y  draw, and Z  win
	 * @return points (1 for Rock, 2 for Paper, and 3 for Scissors) + (0 if you lost, 3 if the round was a draw, and 6 if you won).
	 */
	private static int getStrategyRoundPoints(final String theirMovement, final String ourDecission) {
		final String shape = getShapeByStrategy(theirMovement, ourDecission);
		return getRoundPoints(theirMovement, shape);
	}

	/**
	 * Returns the shape needed to lose, draw or win based in the movement of our rival.
	 *
	 * @param theirMovement
	 * 		A for Rock, B for Paper, and C for Scissors
	 * @param ourDecission
	 * 		X  lose, Y  draw, and Z  win
	 * @return X for Rock, Y for Paper, and Z for Scissors
	 */
	private static String getShapeByStrategy(final String theirMovement, final String ourDecission) {
		if (ROCK.equalsIgnoreCase(theirMovement)) {
			if (LOSE.equalsIgnoreCase(ourDecission)) {
				return OUR_SCISSORS;
			} else if (WIN.equalsIgnoreCase(ourDecission)) {
				return OUR_PAPER;
			}
			return OUR_ROCK;
		} else if (PAPER.equalsIgnoreCase(theirMovement)) {
			if (LOSE.equalsIgnoreCase(ourDecission)) {
				return OUR_ROCK;
			} else if (WIN.equalsIgnoreCase(ourDecission)) {
				return OUR_SCISSORS;
			}
			return OUR_PAPER;
		} else {
			if (LOSE.equalsIgnoreCase(ourDecission)) {
				return OUR_PAPER;
			} else if (WIN.equalsIgnoreCase(ourDecission)) {
				return OUR_ROCK;
			}
			return OUR_SCISSORS;
		}
	}

}

Return to Advent of Code 2022 main page.

1 Comment

Leave a Comment

This site uses Akismet to reduce spam. Learn how your comment data is processed.